#include "debug.h"

#include <stdint.h>

// From http://forums.arm.com/index.php?/topic/13949-cycle-count-in-cortex-m3/
// These registers are undocumented officially...
volatile uint32_t * const DWT_CYCCNT  = (uint32_t*) 0xe0001004;
volatile uint32_t * const DWT_CONTROL = (uint32_t*) 0xe0001000;
volatile uint32_t * const SCB_DEMCR   = (uint32_t*) 0xe000edfc;

/*
 * Starts or restarts the cycle counter.
 */
inline void cycle_start() {
	*SCB_DEMCR |= 0x01000000;
	*DWT_CYCCNT = 0;
	*DWT_CONTROL |= 1;
}

/*
 * Returns the number of cycles elapsed since the cycle counter was
 * started or last restarted.
 */
inline int cycle_get() {
	return *DWT_CYCCNT;
}
